import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)
import java.awt.Color;

/**
 * A piano that can be played with the computer keyboard.
 * 
 * @author Michael Kolling
 * @version 1.0
 */
public class Piano extends World
{// Downloaded a bunch of sounds, but got compiler errors on alot due to not supported even though extensions were correct!?
    //  So, after much frustation, I went with some repetition.
    public static final int VISUALIZER_HIEGHT =340;
    private String[] whiteKeys =
        { "A", "S", "D", "F", "G", "H", "J", "K", "L", ";", "'", "\\" };
    private  String[] whiteNotes =
        { "BrightPad", "wshore", "jungle", "charbon", "Restaraunt", "aqua", "BrightPad", "teleport", "jungle", "aqua", "carpenterfrog", "charbon" };

    private String[] blackKeys =
        { "W", "E", "", "T", "Y", "U", "", "O", "P", "", "]" }; 
    private String[] blackNotes =
        { "carpenterfrog", "Restaraunt", "", "carpenterfrog", "BrightPad", "wshore", "", "jungle", "teleport", "", "jungle" }; 

    private Visualizer screen = new Visualizer();

    private Color[] whiteKeyColors =
        {
            new Color(230, 101, 166, 128),
            new Color(198, 227, 171, 128),
            new Color(146, 223, 227, 128),
            new Color(229, 156, 215, 128),
            new Color(51, 255, 0, 128),
            new Color(0, 102, 255, 128),
            new Color(255, 102, 255, 128),
            new Color(153, 255, 51, 128),
            new Color(0, 255, 204, 128),
            new Color(255, 204, 0, 128), 
            new Color(0, 255, 255, 128), 
            new Color(102, 255, 153, 128)
        };
    /**
     * Make the piano. This means mostly, apart from defining the size,
     * making the keys and placing them into the world.
     */
    public Piano() 
    {
        super(800, 340+340, 1);
        makeKeys();
        showMessage();
        addObject(screen, getWidth() / 2, screen.getImage().getHeight() / 2);
        //
    }

    /**
     * Create the piano keys (white and black) and place them in the world.
     */
    private void makeKeys()

    {
        // make the white keys
        for(int i = 0; i < whiteKeys.length; i++) {
            Key key = new Key(whiteKeys[i], whiteNotes[i]+".wav", "white-key.png", "white-key-down.png");
            addObject(key, 54 + (i*63), 140+340);
            key.setVisualizer(screen);
            key.setColor(new Color(
                        Greenfoot.getRandomNumber(255),
                       Greenfoot.getRandomNumber(255),
                        Greenfoot.getRandomNumber(255), 200));
        }

        // make the black keys
        for(int i = 0; i < whiteKeys.length-1; i++) {
            if( ! blackKeys[i].equals("") ) {
                Key key = new Key(blackKeys[i], blackNotes[i]+".wav", "black-key.png", "black-key-down.png");
                addObject(key, 85 + (i*63), 86+340);
                key.setVisualizer(screen);
                key.setColor(new Color(
                        Greenfoot.getRandomNumber(255),
                       Greenfoot.getRandomNumber(255),
                        Greenfoot.getRandomNumber(255), 200));
            }
        }
    }

    public void showMessage()
    {
        GreenfootImage bg = getBackground();
        bg.setColor(Color.WHITE);
       bg.drawString("Press Reset to choose background color, then Run. ",250, 305);
        bg.drawString("Use mouse to play piano ",300, 320);
    }

}